var gc = gc || {};

function init() {
  function qaWatchdog_Interface(packetParser, sendPacket) {
    OCFBaseEx.apply(this, arguments);
    this.handlers = [];
  }

  qaWatchdog_Interface.prototype = Object.create(OCFBaseEx.prototype);
  qaWatchdog_Interface.prototype.constructor = qaWatchdog_Interface;
  OCFBaseEx.prototype.add_interface("qawatchdog", qaWatchdog_Interface);

  qaWatchdog_Interface.prototype.ensureConfigured = function(config_seq) {};

  let createWatchdogPacket = function(unit, params) {
    console.log("unit:", unit, "Params:", params);
    let packet = [
      [unit, params.questionAddress, params.answerAddress, params
        .i2cAddress
      ]
    ];
    packet = packet.concat([
      [params.i2c, params.spiWatchdogPage, params.answerCountRegister,
        params.maskForAnswerCountRegister
      ]
    ]);
    packet = packet.concat([
      [params.enable, params.spiMode, params.wrongAnswer, 0]
    ]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayQuestion, 32, "little")]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer3, 32, "little")]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer2, 32, "little")]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer1, 32, "little")]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer0, 32, "little")]);
    return packet;
  };

  let Watchdog_Interface = 0x1A;
  let cmd_QAWatchdog_Enable = 0x00;
  let cmd_QAWatchdog_Config = 0x01;
  let cmd_QAWatchdog_ExecuteStep = 0x02;

  qaWatchdog_Interface.prototype.get_interface_type = function() {
    return Watchdog_Interface;
  };

  /**
   * Initialize symbols for device
   *
   * @param settings - The interface settings defined in the system.json
   * @param registerModel - The register model
   */
  qaWatchdog_Interface.prototype.initSymbolsForDevice = function(settings,
    registerModel) {
    OCFBaseEx.prototype.initSymbolsForDevice.apply(this, arguments);
  };

  qaWatchdog_Interface.prototype.QAWatchdog_Config = function(unit, params) {
    console.dir(params);
    let watchdogPacket = createWatchdogPacket(unit, params);
    let payload = [0];
    // qaWatchdog_Interface.sendPacket(watchdogPacket);
    return this.h2c_command(Watchdog_Interface, unit, cmd_QAWatchdog_Config,
      watchdogPacket, payload);
  };

  qaWatchdog_Interface.prototype.QAWatchdog_Enable = function(unit, params) {
    let watchdogPacket = [];
    watchdogPacket = watchdogPacket.concat(OCFBase.prototype.value_to_bytes
      .call(this, unit));
    watchdogPacket = watchdogPacket.concat(OCFBase.prototype.value_to_bytes
      .call(this, params.enable));
    return this.h2c_command(Watchdog_Interface, unit, cmd_QAWatchdog_Enable,
      watchdogPacket);
  };

  qaWatchdog_Interface.prototype.QAWatchdog_ExecuteStep = function(unit) {
    return this.h2c_command(Watchdog_Interface, unit,
      cmd_QAWatchdog_ExecuteStep, []);
  };
}

if (gc.databind && gc.databind.AEVMCodec) {
  init();
} else {
  document.addEventListener("WebComponentsReady", init);
}
